--[[ LFDQueue ]]

if not FixR then return end

local DefaultO = {
}
local misc = {
  ["desc"] = "LFDQueue";
  ["alpha"] = true;
  ["GUI"] = {
    [1] = {
      ["type"] = "Button";
      ["opt"] = "show status";
      ["func"] = function(self) self:SetOption("show"); end;
    };
  };
}

local M = FixR:NewModule("LFDQueue", DefaultO, misc)

local frame = nil
local frameEvents = {};
local status = {};
local function initFrame()
  frame = CreateFrame("Frame")
  frame:SetScript("OnEvent", function(self, event, ...)
    frameEvents[event](self, ...);
  end);
  
  --frame.dungeonID = 789 --WoD random heroic dungeon
  --frame.active
end

--[[
function frameEvents:LFG_QUEUE_STATUS_UPDATE(...)
  --local hasData, leaderNeeds, tankNeeds, healerNeeds, dpsNeeds, instanceType, instanceName, averageWait, tankWait, healerWait, damageWait, myWait, queuedTime = GetLFGQueueStats()
  print("LFG_QUEUE_STATUS_UPDATE")
  --print("hasData", hasData, "leaderNeeds", leaderNeeds, "tankNeeds", tankNeeds, "healerNeeds", healerNeeds, "dpsNeeds", dpsNeeds, "instanceType", instanceType, "instanceName", instanceName, "averageWait", averageWait, "tankWait", tankWait, "healerWait", healerWait, "damageWait", damageWait, "myWait", myWait, "queuedTime", queuedTime)
  --Try each LFG type
  for i=1, NUM_LE_LFG_CATEGORYS do
    local mode, submode = GetLFGMode(i);
    if ( mode ) then
      local hasData, leaderNeeds, tankNeeds, healerNeeds, dpsNeeds, totalTanks, totalHealers, totalDPS, instanceType, instanceSubType, instanceName, averageWait, tankWait, healerWait, damageWait, myWait, queuedTime = GetLFGQueueStats(i);
      --local hasData, leaderNeeds, tankNeeds, healerNeeds, dpsNeeds, instanceType, instanceName, averageWait, tankWait, healerWait, damageWait, myWait, queuedTime = GetLFGQueueStats(i)
      --print("hasData", hasData, "leaderNeeds", leaderNeeds, "tankNeeds", tankNeeds, "healerNeeds", healerNeeds, "dpsNeeds", dpsNeeds, "instanceType", instanceType, "instanceName", instanceName, "averageWait", averageWait, "tankWait", tankWait, "healerWait", healerWait, "damageWait", damageWait, "myWait", myWait, "queuedTime", queuedTime)
      status[i] = {}
      status[i]["MODE"] = mode..", "..submode
      status[i]["hasData"] = hasData
      status[i]["leaderNeeds"] = leaderNeeds
      status[i]["tankNeeds"] = tankNeeds
      status[i]["healerNeeds"] = healerNeeds
      status[i]["dpsNeeds"] = dpsNeeds
      status[i]["totalTanks"] = totalTanks
      status[i]["totalHealers"] = totalHealers
      status[i]["totalDPS"] = totalDPS
      status[i]["instanceType"] = instanceType
      status[i]["instanceSubType"] = instanceSubType
      status[i]["instanceName"] = instanceName
      status[i]["averageWait"] = averageWait
      status[i]["tankWait"] = tankWait
      status[i]["healerWait"] = healerWait
      status[i]["damageWait"] = damageWait
      status[i]["myWait"] = myWait
      status[i]["queuedTime"] = queuedTime
      - -[ [
      local entry = QueueStatusFrame_GetEntry(self, nextEntry);
      QueueStatusEntry_SetUpLFG(entry, i);
      entry:Show();
      totalHeight = totalHeight + entry:GetHeight();
      nextEntry = nextEntry + 1;

      showMinimapButton = true;
      if ( mode == "queued" ) then
        animateEye = true;
      end
      - -] ]
    end
  end
end
--]]
function frameEvents:LFG_QUEUE_STATUS_UPDATE(...)
end

function M:Load()
  if not frame then
    initFrame()
  end
  for k, v in pairs(frameEvents) do
    frame:RegisterEvent(k);
  end
end

function M:Unload()
  if frame then
    for k, v in pairs(frameEvents) do
      frame:UnregisterEvent(k);
    end
  end
end

function M:SetOption(arg1, arg2)
  if arg1 == "start" then
    --FixR_ShowValues(status, "")
  end
end

function M:ShowOptions()
end
